// 



const RouterSchema = require('./router_schema');

/**
 * ExpressRouterSchema
 *
 * @class ExpressRouterSchema
 * @extends {RouterSchema}
 */
class ExpressRouterSchema extends RouterSchema {
  constructor(option) {
    super(option);
  }
  /**
   * Implement RouterSchema.handler()
   *
   * @override
   * @param {$Request} req
   * @param {$Response} res
   * @param {NextFunction} next
   * @returns {ValidateData}
   * @memberof ExpressRouterSchema
   */
  handler(req, res, next) {
    const { query, body } = req;
    const callback = (error, value) => {
      if (error) {
        return next(error);
      }
      if (value) {
        req.query = value.query;
        req.body = value.body;
      }

      return next();
    };
    return { data: { query, body }, callback };
  }
}

module.exports = ExpressRouterSchema;
