// 



const RouterSchema = require('./router_schema');
/**
 * KoaRouterSchema
 *
 * @class KoaRouterSchema
 * @extends {RouterSchema}
 */
class KoaRouterSchema extends RouterSchema {
  constructor(option) {
    super(option);
  }

 /**
   * Implement RouterSchema.handler()
   *
   * @override
   * @param {Context} ctx
   * @param {() => Promise<void>} next
   * @returns {ValidateData}
   * @memberof KoaRouterSchema
   */
  handler(ctx, next) {
    const { query } = ctx;
    const { body } = ctx.request;
    const callback = (error, value) => {
      if (error) {
        return Promise.reject(error);
      }
      if (value) {
        ctx.query = value.query;
        ctx.request.body = value.body;
      }

      return next();
    };
    return { data: { query, body }, callback };
  }
}

module.exports = KoaRouterSchema;
