// 


/**
 * RequestHandler
 *
 * @class RequestHandler
 * @implements {IRequestHandler}
 */
class RequestHandler {
  constructor(convert, validator) {
    this.validator = validator;
    this.convert = convert;
  }
  /**
   * handle the request, will be registered to the router
   *
   * @param {...any} args
   * @returns {Promise<void>}
   * @memberof RequestHandler
   */
  handler(...args) {
    const { data, callback } = this.convert(...args);
    const { error, value } = this.validator.validate(data);
    return callback(error, value);
  }
}

module.exports = RequestHandler;
