// 


const Joi = require('joi');

/**
 * A Joi validator's wrapper
 *
 * @class RequestHandler
 * @implements {IValidator}
 */
class RequestHandler {
  constructor(schema, joiOption) {
    this.joiValidator = Joi.compile(schema);
    this.joiOption = joiOption;
  }
  /**
   * validate the data via joi
   *
   * @param {Object} requestData
   * @returns {ValidateResult}
   * @memberof RequestHandler
   */
  validate(requestData) {
    return this.joiValidator.validate(requestData, this.joiOption);
  }
}

module.exports = RequestHandler;
